<?php
/*
Cashenvoy Payment Gateway
By: ChemikaWale
Email: oyelamioyewale@gmail.com

*/

class CashEnvoy_Mycashenvoy_PaymentController extends Mage_Core_Controller_Front_Action {
	// The redirect action is triggered when someone places an order
	public function redirectAction() {
		$this->loadLayout();
        $block = $this->getLayout()->createBlock('Mage_Core_Block_Template','mycashenvoy',array('template' => 'mycashenvoy/redirect.phtml'));
		$this->getLayout()->getBlock('content')->append($block);
        $this->renderLayout();
	}

	// The response action is triggered when your cashenvoy gateway sends back a response after processing the customer's payment
	public function responseAction() {

        $transref = Mage::getSingleton('core/session')->getTransactionRef();
        $orderId = Mage::getSingleton('core/session')->getOrderNumber();
        $mertid = Mage::getSingleton('core/session')->getMerchantId();
        $amount = Mage::getSingleton('core/session')->getTransactionAmount();
        $secretkey = Mage::getSingleton('core/session')->getSecretkey();

        $cdata = $secretkey.$transref.$mertid;
        $signature = hash_hmac('sha256', $cdata, $secretkey, false);

        $client = new Zend_Http_Client();
        $client->setMethod(Zend_Http_Client::POST);
//        // change the sandbox in the url below to webservice when you are ready to go live.
        $client->setUri('https://www.cashenvoy.com/sandbox/?cmd=requery');
       $client->setParameterPost(array(
            'mertid'  => urlencode($mertid),
           'transref'   => urlencode($transref),
           'signature' =>urlencode($signature)
        ));

         $responsed = $client->request();
//
//
        $response = $responsed->getBody();
        $data = explode('-',$response);
        $cnt = count($data);
//// if the $raw_reponse does not explode to 3 parts then there is an error so we echo $raw_response to see what it is
        if($cnt!=3){  echo $response; }
//
//// the returned information is transref, status and amount respectively
        if($cnt==3)
        {
            $returned_transref = $data[0];
            $returned_status = $data[1];
            $returned_amount = $data[2];

//            // will handle this response in the next plugin update.
        switch($returned_status)
        {
            case C00:
//
                 if( $returned_amount == $amount){
                $returned_status="Transaction Successful";
                // Payment was successful, so update the order's state, send order email and move to the success page
                $order = Mage::getModel('sales/order');
                $order->loadByIncrementId($orderId);
                $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true, 'Gateway has authorized the payment.');

                $order->sendNewOrderEmail();
                $order->setEmailSent(true);

                $order->save();
                      }
                 else{
                     $returned_status="Payment Amount altered";
                 }
                break;
            case C01:
                $returned_status="User Cancellation";
                break;
            case C02:
                $returned_status="User cancellation by inactivity";
                break;
            case C03:
                $returned_status="No transaction record";
                break;
            case C04:
                $returned_status="Insufficient funds";
                break;
            case C05:
                $returned_status="Transaction failed. Contact support@cashenvoy.com for more information.";
                break;
            default:
                $returned_status="We can not process your transaction as at this time pls try again later";
//
        }
//


            Mage::getSingleton('core/session')->setTransferStatus($returned_status);
            Mage::getSingleton('core/session')->setTransferAmount($returned_amount);
            Mage::getSingleton('core/session')->setTransferRef($returned_transref);

			Mage::getSingleton('checkout/session')->unsQuoteId();
				
				Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/success', array('_secure'=>true));
    }
	else {
				// There is a problem in the response we got
			$this->cancelAction();
			Mage_Core_Controller_Varien_Action::_redirect('checkout/onepage/failure', array('_secure'=>true));
			}

	}
	
	// The cancel action is triggered when an order is to be cancelled
	public function cancelAction() {
        if (Mage::getSingleton('checkout/session')->getLastRealOrderId()) {
            $order = Mage::getModel('sales/order')->loadByIncrementId(Mage::getSingleton('checkout/session')->getLastRealOrderId());
            if($order->getId()) {
				// Flag the order as 'cancelled' and save it
				$order->cancel()->setState(Mage_Sales_Model_Order::STATE_CANCELED, true, 'Gateway has declined the payment.')->save();
			}
        }
	}
}